#include <amxmodx>
#include <amxmisc>
#include <csx>

#define PLUGIN "EventSound"
#define VERSION "1.0"
#define AUTHOR "R3X"

#define CFG_FILE "event_sound.ini"
#define EVENTS_NUM 9 

#define EVENT_PLANT 0
#define EVENT_DEFUSE 1
#define EVENT_KILL 2
#define EVENT_TK 3
#define EVENT_HS 4
#define EVENT_DBKILL 5
#define EVENT_SUICIDE 6
#define EVENT_GRENADE 7
#define EVENT_BOMB_EXPLODE 8

//Interval of killing to assign it to Double
#define DBKILL_INTERVAL 0

new gEvents[EVENTS_NUM][]={
"plant",
"defuse",
"kill",
"tk",
"hs",
"dbkill",
"suicide",
"grenade",
"c4_explode"
};
new Array:gSounds[EVENTS_NUM];

new gLastKill[33]={0,...};

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	register_event("DeathMsg", "eventDeathMsg", "a");
}
public plugin_precache(){
	new szCfgFile[128];
	new iLen=get_configsdir(szCfgFile, 100);
	formatex(szCfgFile[iLen], 127, "/%s", CFG_FILE);
	if(!file_exists(szCfgFile))
		return set_fail_state("Brak pliku konfiguracyjnego");
	new szLine[128], szEvent[11];
	new iEvent=-1;
	for(new i=0;i<EVENTS_NUM;i++)
		gSounds[i] = ArrayCreate(60, 1);
	for(new i=0;read_file(szCfgFile, i, szLine, 71, iLen);i++){
		trim(szLine);
		if(szLine[0]==';' || equal(szLine, "")) continue;
		parse(szLine, szEvent, 10, szLine, 59);
		trim(szEvent);
		iEvent=get_event_id(szEvent);
		if(-1!=iEvent){
			trim(szLine);
			ArrayPushString(gSounds[iEvent], szLine);
			precache_sound(szLine);
		}
	}
	return PLUGIN_CONTINUE;
}
//--------------------------
//Events
//--------------------------
public bomb_planted(id)
	EVENT_play(EVENT_PLANT);

public bomb_defused(id)
	EVENT_play(EVENT_DEFUSE);
public bomb_explode()
	EVENT_play(EVENT_BOMB_EXPLODE);

public grenade_throw(index, greindex, wId)
	EVENT_play(EVENT_GRENADE);
	
public eventDeathMsg(){
	new iEvent;
	new iKiller=read_data(1), iVictim=read_data(2);
	if(is_user_connected(iKiller)){
		if( get_user_team(iKiller) == get_user_team(iVictim) )
			iEvent=EVENT_TK;
		else{
			new iNow=get_systime();
			if( (iNow - gLastKill[iKiller]) <= DBKILL_INTERVAL)
				iEvent=EVENT_DBKILL;
			else
				iEvent=read_data(3)?EVENT_HS:EVENT_KILL;
			gLastKill[iKiller]=iNow;
		}
	}
	else
		iEvent=EVENT_SUICIDE;
	EVENT_play(iEvent);
}

//--------------------------
//Other
//--------------------------
get_event_id(const szEvent[]){
	for(new i=0;i<sizeof gEvents;i++)
		if(equali(gEvents[i], szEvent))
			return i;
	return -1;
}
EVENT_play(EVENT){
	new iNum = ArraySize(gSounds[EVENT]);
	if(iNum==0) return;
	
	new szSound[60];
	iNum=random_num(0, iNum-1);
	ArrayGetString(gSounds[EVENT], iNum, szSound, 59);
	play(0, szSound);
}
play(id, sound[]){
	new end=strlen(sound)-4;
	if(containi(sound,".mp3") == end && end>0)
		client_cmd(id,"mp3 play sound/%s",sound);
	else if(containi(sound,".wav") == end && end>0)
		client_cmd(id, "spk sound/%s",sound);
	else
		client_cmd(id, "speak %s",sound);
}
